import { QueryList, AfterContentInit, ElementRef, EventEmitter, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { MdbStepComponent } from './step.component';
import { BooleanInput } from '@angular/cdk/coercion';
import * as i0 from "@angular/core";
export declare type MdbStepperOrientation = 'horizontal' | 'vertical';
export interface MdbStepChangeEvent {
    activeStep: MdbStepComponent;
    activeStepIndex: number;
    previousStep: MdbStepComponent;
    previousStepIndex: number;
}
export declare class MdbStepperComponent implements AfterContentInit, OnDestroy {
    private _cdRef;
    steps: QueryList<MdbStepComponent>;
    stepTitles: QueryList<ElementRef>;
    stepContents: QueryList<ElementRef>;
    container: ElementRef;
    orientation: MdbStepperOrientation;
    get linear(): boolean;
    set linear(value: boolean);
    private _linear;
    get mobile(): boolean;
    set mobile(value: boolean);
    private _mobile;
    mobileBarBreakpoint: number;
    get markAsCompleted(): boolean;
    set markAsCompleted(value: boolean);
    private _markAsCompleted;
    stepChange: EventEmitter<MdbStepChangeEvent>;
    constructor(_cdRef: ChangeDetectorRef);
    private _destroy;
    private _activeStepIndex;
    private _activeStep;
    get allStepsNumber(): number;
    getProgressBarWidth(): number;
    get activeStepIndex(): number;
    set activeStepIndex(value: number);
    private _isStepValid;
    getAnimationState(index: number): string;
    private _getStepByIndex;
    next(): void;
    previous(): void;
    submit(): void;
    setNewActiveStep(index: number): void;
    private _markCurrentAsDone;
    private _markCurrentAsWrong;
    private _markStepControlsAsDirty;
    private _removeStepValidationClasses;
    private _isNewStepLinear;
    private _setActiveStep;
    private _removeCurrentActiveStep;
    resetAll(): void;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    static ngAcceptInputType_linear: BooleanInput;
    static ngAcceptInputType_mobile: BooleanInput;
    static ngAcceptInputType_markAsCompleted: BooleanInput;
    static ɵfac: i0.ɵɵFactoryDeclaration<MdbStepperComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MdbStepperComponent, "mdb-stepper", ["mdbStepper"], { "orientation": "orientation"; "linear": "linear"; "mobile": "mobile"; "mobileBarBreakpoint": "mobileBarBreakpoint"; "markAsCompleted": "markAsCompleted"; }, { "stepChange": "stepChange"; }, ["steps"], never>;
}
